(*
    q{(http://www.kobira.co.jp/sakura/d_str.htm)
    Windows3.1/95/NT(Delphi) String, StringList 01/01/13
    _E[h


	**********
    readme
	**********

    SJISEUC̑oϊUNITłB25/Oct./'97
    http://www.kobira.co.jp/sakura/windows.htm
    author Seiji-Yasuda seiji@kobira.co.jp

    UNIT̓t[EFAłB
    ȂɂĂA̐ӔCɂĎgpĉB

    ֐ꗗ
    function  EUC_isank(x:Word):Boolean;
    function  EUC_iskana(x:Word):Boolean;
    function  EUC_iskana2nd(x:Word):Boolean;
    function  EUC_iskanji(x:Word):Boolean;
    function  EUC_iskanji2nd(x:Word):Boolean;
    function  EUC_isank2nd(x:Word):Boolean;
    function  EUC_is2byte(x:Word):Boolean;
    function  SJIS_is2byte(x:Word):Boolean;
    function  EUCtoJIS(x:Word):Word;
    function  JIStoEUC(x:Word):Word;
    function  JIStoSJIS(x:Word):Word;
    function  SJIStoJIS(x:Word):Word;
    function  EUCtoSJIS_String( src:String ):String;
    function  SJIStoEUC_String( src:String ):String;

    EUCSJIS̕ϊׂɂ́AEUCtoSJIS_StringSJIStoEUC_Strinĝ
    gp΁AǂƎv܂BΐAJISɕϊAĂ܂B

    ⓙ܂A[B
    ͕WIȓ{lȂ̂ŁA{ł肢܂B(^_^;)

    cɂ̃zr[[ÜlłseijiB
    http://www.kobira.co.jp/sakura/windows.htm
    e-mail:seiji@kobira.co.jp
*)

{=====================================================================}
{ JEuc Unit for Delphi 2.0                               25/Oct./'97  }
{ http://www.kobira.co.jp/sakura/windows.htm                          }
{ author Seiji-Yasuda seiji@kobira.co.jp                              }
{                                                                     }
{ You may use it freely at your own risk in any kind of environment.  }
{                                                                     }
{ 3/May./'86 function for MS-C ver 5.0 on DOS.                        }
{ 22/Feb./'89 C -> function for TP on DOS.                            }
{ 2/Oct./'97 unit for Delphi 2.0 on Windows.                          }
{ 25/Oct./'97 freeware.                                               }
{                                                                     }
{=====================================================================}
unit jeuc;

interface

uses SysUtils;

function  EUC_isank(x:Word):Boolean;
function  EUC_iskana(x:Word):Boolean;
function  EUC_iskana2nd(x:Word):Boolean;
function  EUC_iskanji(x:Word):Boolean;
function  EUC_iskanji2nd(x:Word):Boolean;
function  EUC_isank2nd(x:Word):Boolean;
function  EUC_is2byte(x:Word):Boolean;

function  SJIS_is2byte(x:Word):Boolean;

function  EUCtoJIS(x:Word):Word;
function  JIStoEUC(x:Word):Word;

function  JIStoSJIS(x:Word):Word;
function  SJIStoJIS(x:Word):Word;
function  EUCtoSJIS_String( src:String ):String;
function  SJIStoEUC_String( src:String ):String;

implementation


//-----------------------------------------------------------
// EUC is 1byte ank
//-----------------------------------------------------------
function  EUC_isank(x:Word):Boolean;
begin
  x := x and $00ff;
  if (x < $8e) then
    Result := True
  else
    Result := False;
end;

//-----------------------------------------------------------
// EUC is kana
//-----------------------------------------------------------
function EUC_iskana(x:Word):Boolean;
begin
  x := x and $00ff;
  if x = $8e then
    Result := True
  else
    Result := False;
end;


//-----------------------------------------------------------
// EUC is kana 2nd
//-----------------------------------------------------------
function EUC_iskana2nd(x:Word):Boolean;
begin
  x := x and $00ff;
  if (x >= $a0) and (x <= $df) then
    Result := True
  else
    Result := False;
end;


//-----------------------------------------------------------
// EUC is kanji
//-----------------------------------------------------------
function EUC_iskanji(x:Word):Boolean;
begin
  x := x and $00ff;
  if ((x >= $90) and (x <= $9f)) or
       ((x >= $a1) and (x <= $fe)) then
    Result := True
  else
    Result := False;
end;


//-----------------------------------------------------------
// EUC is kanji 2nd
//-----------------------------------------------------------
function EUC_iskanji2nd(x:Word):Boolean;
begin
  x := x and $00ff;
  if (x >= $a1) and (x <= $fe) then
    Result := True
  else
    Result := False;
end;


//-----------------------------------------------------------
// EUC is ank 2nd
//-----------------------------------------------------------
function EUC_isank2nd(x:Word):Boolean;
begin
  x := x and $00ff;
  if (x >= $20) and (x <= $7f) then
    Result := True
  else
    Result := False;
end;


//-----------------------------------------------------------
// EUC is 2byte character.
//-----------------------------------------------------------
function EUC_is2byte(x:Word):Boolean;
begin
  Result := True;
  if EUC_isank(x) then begin
    Result := False;
    exit;
  end;
  if EUC_iskanji(x) then
    exit;
  if EUC_iskana(x) then
    exit;
  Result := False;
end;


//-----------------------------------------------------------
// SJIS is 2byte character.
//-----------------------------------------------------------
function SJIS_is2byte(x:Word):Boolean;
begin
  x := x and $00ff;
  if (( x >= $80) and (x <= $9f)) or
       ((x >= $e0) and (x <= $fc))  then
    Result := True
  else
    Result := False;
end;


//-----------------------------------------------------------
// convert EUC(japanese) to JIS(japanese)
//-----------------------------------------------------------
function EUCtoJIS(x:Word):Word;
var
  x1,x2:Word;
begin

  x1 := x and $ff;            // 1st byte.
  x2 := (x shr 8) and $ff;    // 2nd byte.

  if EUC_isank(x) then begin
    // ANK
	Result := x1;
    exit;
  end;

  if EUC_iskanji(x1) then begin
    // KANJI
    if EUC_iskanji2nd(x2) then begin
      Result := ((x1 and $7f) shl 8) + ( x2 and $7f);
      exit;
    end else begin
      Result := x2;
      exit;
	end;
  end;

  if EUC_iskana(x1) then begin
    if EUC_iskana2nd(x2) then begin
	  // 1byte KANA
	  Result := x2;
      exit;
    end else if EUC_isank2nd(x2) then begin
      // 1byte ANK
	  Result := x2;
      exit;
	end else begin
      // unknown Character ?
	  Result := x2;
      exit;
    end;
  end;

  // ANK
  Result := x1;

end;


//-----------------------------------------------------------
// convert JIS(japanese) to EUC(japanese)
//-----------------------------------------------------------
function JIStoEUC(x:Word):Word;
begin
  if x < $00a0 then begin
    // ANK
    Result := x;
    exit;
  end;

  if (x >= $a0) and (x <= $df) then begin
    // kanji of 1byte width.
    Result := ($8e shl 8) or x;
    exit;
  end;

  if ( x and $ff00) <> 0 then begin
	Result :=  ((((x shr 8) and $ff ) or $80) shl 8) or ((x and $ff) or $80);
    exit;
  end;

  Result := x;

end;



//-----------------------------------------------------------
// convert SHIFT-JIS(japanese) to JIS(japanese)
//-----------------------------------------------------------
function SJIStoJIS(x:Word):Word;
var
  x1,x2:Word;
begin
  // The exception processing of this function.
  if ( x = $8520) then begin
    Result := $2121;
    exit;
  end;

  x1 := x and $00ff;
  x2 := x shr 8;

  if ( x2 = $80) then begin
    Result := x;
    exit;
  end;
  if (x2 < $a0) then
    x2 := x2 - $70
  else if ( x2 < $f0 ) then
    x2 := x2 - $b0
  else begin
    Result := x;
    exit;
  end;
  if x1 >= $80 then
    dec(x1);
  x2 := x2 shl 1;
  if x1 >= $9e then
    x1 := x1 - $5e
  else
    dec(x2);
  x1 := x1 - $1f;
  if x2 = $2a then begin
    Result := x1 or $80;
    exit;
  end;
  if x2 = $29 then
    x2 := 0;
  Result := ((x2 and $ff) shl 8) + (x1 and $ff);

end;


//-----------------------------------------------------------
// convert JIS(japanese) to SHIFT-JIS(japanese)
//-----------------------------------------------------------
function JIStoSJIS(x:Word):Word;
var
  x1,x2:Word;
begin
  // The exception processing of this function.
  if x = $2121 then  begin
    Result := $8140;
    exit;
  end;

  x1 := (x and $00ff) + $1f;
  x2 := x shr 9;
  if x and $0100 = 0 then begin
    dec(x2);
	x1 := x1 + $5e;
  end;
  if x1 >= $7f then
    inc(x1);
  if x2 < $2f then
    x2 := x2 + $71
  else
    x2 := x2 + $b1;
  Result := ( (x2 and $00ff) shl 8) + (x1 and $00ff);
end;


//-----------------------------------------------------------
// convert EUC String(japanese) to SHIFT-JIS String(japanese)
//-----------------------------------------------------------
function EUCtoSJIS_String( src:String ):String;
var
  l,n:Integer; w:word;
begin
  Result := '';
  l := Length(src);
  n := 1;
  while n <= l do begin
    if EUC_is2byte(Word(src[n])) then begin
      if (l - n) >= 1 then begin
        // High, Low,,
        w := Word(src[n]) + Word(src[n+1]) shl 8;
        inc(n);
        inc(n);
      end else begin
        w := Word(src[n]);
        inc(n);
      end;
      w := EUCtoJIS(w);
      w := JIStoSJIS(w);
      Result := Result + Char( w shr 8 ) + Char(w and $ff);
    end else begin
      w := Word(src[n]);
      Result := Result + Char(w and $ff);
      inc(n);
    end;
  end;
end;


//-----------------------------------------------------------
// SHIFT-JIS String(japanese) to convert EUC String(japanese)
//-----------------------------------------------------------
function SJIStoEUC_String( src:String ):String;
var
  l,n:Integer; w:word;
begin
  Result := '';
  l := Length(src);
  n := 1;
  while n <= l do begin
    if SJIS_is2byte(Word(src[n])) then begin
      if (l - n) >= 1 then begin
        // Low, High,,
        w := Word(src[n]) shl 8 + Word(src[n+1]);
        inc(n);
        inc(n);
      end else begin
        w := Word(src[n]);
        inc(n);
      end;
      w := SJIStoJIS(w);
      w := JIStoEUC(w);
      Result := Result + Char( w shr 8 ) + Char(w and $ff);
    end else begin
      w := Word(src[n]);
      Result := Result + Char(w and $ff);
      inc(n);
    end;
  end;
end;



end.
